﻿using System;
using System.Text;

namespace NAK
{
    public class DMYDiff
    {
        public static int DMYDays(DateTime startDate, DateTime endDate)
        {
            if (endDate < startDate)
            {
                throw new ArgumentException("Η endDate δεν μπορεί να είναι προγενέστερη της startDate", "endDate");
            }

	        int diff = endDate.Year - startDate.Year;
	        if (diff > 0)
	        {
		        if (endDate.Month < startDate.Month)
			        --diff;
		        else if (endDate.Day < startDate.Day)
			        --diff;
	        }

	        return diff;
        }

        public static int DMYMonths(DateTime startDate, DateTime endDate)
        {
            if (endDate < startDate)
            {
                throw new ArgumentException("Η endDate δεν μπορεί να είναι προγενέστερη της startDate", "endDate");
            }

            int diff = endDate.Month - startDate.Month;

            if (endDate.Day < startDate.Day)
                --diff;
            if (diff < 0)
                diff += 12;

            return diff;
        }

        public static int DMYYears(DateTime startDate, DateTime endDate)
        {
            if (endDate < startDate)
            {
                throw new ArgumentException("Η endDate δεν μπορεί να είναι προγενέστερη της startDate", "endDate");
            }
            DateTime dt;
            int diff = 0;

            if (endDate.Day < startDate.Day)
            {
                if (startDate.Month < 12)
                    dt = new DateTime(startDate.Year, startDate.Month + 1, 1, 0, 0, 0);
                else
                    dt = new DateTime(startDate.Year + 1, 1, 1, 0, 0, 0);
                TimeSpan startDatepan = dt - startDate;
                diff = startDatepan.Days + endDate.Day - 1;
            }
            else
            {
                diff = endDate.Day - startDate.Day;
            }

            return diff;
        }

    }
}
